
<?php

/* 
WordPress Function to Add Social Media Share Links to WordPress Using Shortcode
WordPress optimization specialist = RankYa
Automatically inserts social media share links to blog posts, below content.
Simply insert the code in wp-content > themes > yourCurrentTheme > functions.php
Place it anywhere you want the Social Share Links to show (perhaps Sidebar Widget or Footer Widget) using below WordPress shortcode
[insertrankyasharebuttonshortcode]
*/
function rankyasharebuttonshortcode(){ 
	$siteurlfromsettingsgeneral =  get_bloginfo( 'url' );
    $domainparts = parse_url($siteurlfromsettingsgeneral);
    $domain = isset($domainparts['host']) ? $domainparts['host'] : '';
    if (preg_match('/(?P<domain>[a-z0-9][a-z0-9\-]{1,63}\.[a-z\.]{2,6})$/i', $domain, $regs)) {
       $siteurlfromsettingsgeneral = strstr( $regs['domain'], '.', true );
    }
	if(is_single()){
        // Get singular which will allow to add the shortcode on WordPress Widget OR you could just use is_single
        $rankya_url = urlencode( get_permalink() );
        // get_the_title but add space %20
        $rankya_title = str_replace( ' ', '%20', get_the_title());
        // Core Web Vitals are important for shares
        $twitterURL = 'https://twitter.com/intent/tweet?text='.$rankya_title.'&amp;url='.$rankya_url.'&amp;via='.$siteurlfromsettingsgeneral.'';
        $facebookURL = 'https://www.facebook.com/sharer/sharer.php?u='.$rankya_url;
        $whatsappURL = 'whatsapp://send?text='.$rankya_title . ' ' . $rankya_url;
        $linkedInURL = 'https://www.linkedin.com/shareArticle?mini=true&url='.$rankya_url.'&amp;title='.$rankya_title;
			  //if featured image set, use
			  if ( has_post_thumbnail() && is_single() ) {
						  $thumb_id = get_post_thumbnail_id();
						  $thumb_url = wp_get_attachment_image_src($thumb_id,'full', true); 
						  $pinterestNewURL = 'https://pinterest.com/pin/create/button/?url='.$rankya_url.'&amp;media='.$thumb_url[0].'&amp;description='.$rankya_title;
			  } else{
				  $pinterestNewURL = 'https://pinterest.com/pin/create/button/?url='.$rankya_url.'&amp;description='.$rankya_title;
				  }
       // Add sharing button anywhere 
        $content .= '<div class="social-share-div"><strong>Help others, share this content</strong><div class="share-buttons">';
        $content .= '<a class="buttonlink share-button-profile-twitter" href="'. $twitterURL .'" target="_blank" rel="nofollow noopener">Twitter</a>';
        $content .= '<a class="buttonlink share-button-profile-facebook" href="'.$facebookURL.'" target="_blank" rel="nofollow noopener">Facebook</a>';
        $content .= '<a class="buttonlink share-button-profile-whatsapp" href="'.$whatsappURL.'" target="_blank" rel="nofollow noopener">WhatsApp</a>';
        $content .= '<a class="buttonlink share-button-profile-pinterest" href="'.$pinterestNewURL.'" data-pin-custom="true" target="_blank" rel="nofollow noopener">Pin It</a>';
        $content .= '<a class="buttonlink share-button-profile-linkedin" href="'.$linkedInURL.'" target="_blank" rel="nofollow noopener">LinkedIn</a>';
        $content .= '</div></div>';
	} //END if(is_singular()) check
        return $content;
}
add_shortcode('insertrankyasharebuttonshortcode', 'rankyasharebuttonshortcode');